From b561169aa710f956b489899f48d127c6f71e83fe Mon Sep 17 00:00:00 2001
From: Ralph Bean <rbean@redhat.com>
Date: Apr 16 2015 17:45:56 +0000
Subject: [PATCH 4/254] Make widgets configurable.


---

diff --git a/hubs/models.py b/hubs/models.py
index 4c5bcdf..db4c743 100644
--- a/hubs/models.py
+++ b/hubs/models.py
@@ -22,6 +22,7 @@
 
 
 import datetime
+import json
 import logging
 
 import sqlalchemy as sa
@@ -105,26 +106,43 @@ class Hub(BASE):
             'name': self.name,
         }
 
+def _config_default(context):
+    plugin_name = context.current_parameters['plugin']
+    plugin = widgets.registry[plugin_name]
+
+    print plugin.widget_arguments
+    return json.dumps(dict([
+        (arg.name, arg.default) for arg in plugin.widget_arguments
+    ]))
+
 
 class Widget(BASE):
     __tablename__ = 'widgets'
     idx = sa.Column(sa.Integer, primary_key=True)
-    plugin = sa.Column(sa.String(50))
+    plugin = sa.Column(sa.String(50), nullable=False)
     created_on = sa.Column(sa.DateTime, default=datetime.datetime.utcnow)
     hub_id = sa.Column(sa.String(50), sa.ForeignKey('hubs.name'))
-    #config = ...
-    config = 'lol'
+    _config = sa.Column(sa.String(256), default=_config_default)
 
     index = sa.Column(sa.Integer, nullable=False)
     left = sa.Column(sa.Boolean, nullable=False, default=False)
 
+    @property
+    def config(self):
+        return json.loads(self._config)
+
+    @config.setter
+    def config_setter(self, config):
+        self._config = json.dumps(config)
+
     def __json__(self, reify=False):
         return {
             'plugin': self.plugin,
         }
 
     def render(self, request, session):
-        return widgets.registry[self.plugin](request, session, self.config)
+        plugin = widgets.registry[self.plugin]
+        return plugin(request, session, **self.config)
 
 
 class User(BASE):
diff --git a/hubs/widgets/base.py b/hubs/widgets/base.py
new file mode 100644
index 0000000..69715c8
--- /dev/null
+++ b/hubs/widgets/base.py
@@ -0,0 +1,14 @@
+import collections
+
+Argument = collections.namedtuple('Argument', ('name', 'default', 'help'))
+
+
+def argument(name, default, help):
+    def decorator(func):
+        def inner(*args, **kwargs):
+            return func(*args, **kwargs)
+
+        inner.widget_arguments = getattr(func, 'widget_arguments', [])
+        inner.widget_arguments.append(Argument(name, default, help))
+        return inner
+    return decorator
diff --git a/hubs/widgets/chrome.py b/hubs/widgets/chrome.py
index 16d27e6..afc3e0d 100644
--- a/hubs/widgets/chrome.py
+++ b/hubs/widgets/chrome.py
@@ -24,5 +24,7 @@ def panel(title=None):
                 heading = _panel_heading_template.format(title=title)
             content = func(*args, **kwargs)
             return _panel_template.format(content=content, heading=heading)
+
+        inner.widget_arguments = getattr(func, 'widget_arguments', [])
         return inner
     return decorator
diff --git a/hubs/widgets/dummy.py b/hubs/widgets/dummy.py
index b2e0983..ab4e963 100644
--- a/hubs/widgets/dummy.py
+++ b/hubs/widgets/dummy.py
@@ -1,5 +1,8 @@
 from chrome import panel
+from base import argument
 
 @panel("This is a dummy widget")
-def render(request, session, config):
-    return "hello world"
+@argument(name="text", default="Lorem ipsum dolor...",
+          help="Some dummy text to display.")
+def render(request, session, text):
+    return text

